<template>
	<xn-form-container
		:title="formData.id ? '编辑返利记录' : '增加返利记录'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="代金券金额：" name="rebateAmout">
				<a-input v-model:value="formData.rebateAmout" placeholder="请输入代金券金额" allow-clear />
			</a-form-item>
			<a-form-item label="推荐人：" name="recommendUserId">
				<a-input v-model:value="formData.recommendUserId" placeholder="请输入推荐人" allow-clear />
			</a-form-item>
			<a-form-item label="充值人：" name="rechargeUserId">
				<a-input v-model:value="formData.rechargeUserId" placeholder="请输入充值人" allow-clear />
			</a-form-item>
			<a-form-item label="代金券状态： 1. 待生效 2.已生效：" name="rebateStatus">
				<a-input v-model:value="formData.rebateStatus" placeholder="请输入代金券状态： 1. 待生效 2.已生效" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizRebateRecordForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizRebateRecordApi from '@/api/biz/bizRebateRecordApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizRebateRecordApi
					.bizRebateRecordSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
